import java.awt.BorderLayout;
import java.awt.GridLayout;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Enumeration;

import javax.swing.GroupLayout;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;

import org.apache.tools.zip.*;

/**
 * This code was edited or generated using CloudGarden's Jigloo
 * SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation,
 * company or business for any purpose whatever) then you
 * should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details.
 * Use of Jigloo implies acceptance of these licensing terms.
 * A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
 * THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
 * LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
/**
 * Zip解凍する
 * 
 * java work.UnZip [入力ファイル名]
 * 
 * @author Kentarou Yamane
 */
public class UnZip {

	static private JLabel jLabel1;

	/**
	 * Zip解凍する
	 * 
	 * @param args
	 *            入力ファイル名
	 * @return
	 * @throws IOException
	 */

	public static void main(String[] args) throws IOException {

		{
			// Set Look & Feel
			try {
				javax.swing.UIManager
						.setLookAndFeel("com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		JFrame frame = makeframe();
		dialoga(frame);

	}

	/**
	 * 解凍・圧縮選択ダイアログ
	 */
	private static void dialoga(JFrame frame) throws IOException {
		Object[] オプションボタン = { "Zipファイル作成", "Zipファイル解凍" };
		int resultab = JOptionPane.showOptionDialog(null, "どっちか押してね",
				"make or extract", JOptionPane.DEFAULT_OPTION,
				JOptionPane.WARNING_MESSAGE, null, オプションボタン, オプションボタン[1]);
		System.out.println(resultab);
		if (resultab == 0) {
			makezipd(frame);
		}
		if (resultab == 1) {
			exzipd(frame);
		}
	}

	/**
	 * 解凍ダイアログ
	 */
	private static void exzipd(JFrame frame) throws IOException {
		JOptionPane.showMessageDialog(frame, "解凍するZipファイルを選択してください",
				"インフォメーション", JOptionPane.INFORMATION_MESSAGE);
		JFileChooser chooser = new JFileChooser();
		int result = chooser.showOpenDialog(frame);
		String fname;
		if (result == JFileChooser.APPROVE_OPTION) {
			File f = chooser.getSelectedFile();
			System.out.println(f.getName() + "" + f.getAbsolutePath() + "");
			fname = f.getAbsolutePath();

			Object resultt = JOptionPane.showInputDialog(frame,
					"解凍元ファイルの文字コードを指定してください", "インフォメーション",
					JOptionPane.INFORMATION_MESSAGE, null, new String[] {
							"UTF-8", "shift-JIS", "MS932" , "EUC-JP","ISO2022JP"}, "UTF-8");
			System.out.println((String) resultt);
			JOptionPane.showMessageDialog(frame,
					"出力先フォルダ名を入れください。\n本フォルダ以下に作成されます。", null,
					JOptionPane.INFORMATION_MESSAGE);
			String results = "";
			while (results.length() < 1) {
				results = JOptionPane.showInputDialog(frame,
						"New Directry Name", "Output Directory",
						JOptionPane.INFORMATION_MESSAGE);
				System.out.println(results);
				if (results == null) {
					results = "";
					JOptionPane.showMessageDialog(frame, "出力先フォルダ名が入力されていません",
							"Warning", JOptionPane.ERROR_MESSAGE);
				} else if (results.length() < 1) {
					JOptionPane.showMessageDialog(frame, "出力先フォルダ名が入力されていません",
							"Warning", JOptionPane.ERROR_MESSAGE);
				}
			}
			String contents = "この内容でよろしいですか？\n" + "Filename:" + fname + "\n"
					+ "Encode:" + (String) resultt + "\n" + "Output folder:"
					+ results;
			int resultq = JOptionPane.showConfirmDialog(frame, contents, "ok?",
					1, 1);
			System.out.println(resultq);

			if (resultq == 0) {
				proccessUnZip2(fname, results + "/", (String) resultt);
				JOptionPane.showMessageDialog(frame, "Finish", "解凍終了しました",
						JOptionPane.INFORMATION_MESSAGE);
			}
			if (resultq == 1) {
				dialoga(frame);
			}

		}
	}

	/**
	 * 圧縮ダイアログ
	 */
	private static void makezipd(JFrame frame) throws IOException {
		JOptionPane.showMessageDialog(frame, "Zipファイルに圧縮するフォルダを選択してください",
				"インフォメーション", JOptionPane.INFORMATION_MESSAGE);
		JFileChooser chooser = new JFileChooser();
		chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		int result = chooser.showOpenDialog(frame);
		String fname;
		if (result == JFileChooser.APPROVE_OPTION) {
			File f = chooser.getSelectedFile();
			System.out.println(f.getName() + "" + f.getAbsolutePath() + "");
			fname = f.getAbsolutePath();

			Object resultt = JOptionPane.showInputDialog(frame,
					"出力先Zipファイルの文字コードを指定してください", "インフォメーション",
					JOptionPane.INFORMATION_MESSAGE, null, new String[] {
							"UTF-8", "shift-JIS", "MS932", "EUC-JP","ISO2022JP"}, "UTF-8");
			System.out.println((String) resultt);
			JOptionPane.showMessageDialog(frame,
					"出力先ファイル名を入れください。\n本フォルダに作成されます。\n拡張子も付加してください", null,
					JOptionPane.INFORMATION_MESSAGE);
			String results = "";
			while (results.length() < 1) {
				results = JOptionPane.showInputDialog(frame, "New File Name",
						"Output Zip File", JOptionPane.INFORMATION_MESSAGE);
				System.out.println(results);
				if (results == null) {
					results = "";
					JOptionPane.showMessageDialog(frame, "出力先ファイル名が入力されていません",
							"Warning", JOptionPane.ERROR_MESSAGE);
				} else if (results.length() < 1) {
					JOptionPane.showMessageDialog(frame, "出力先ファイル名が入力されていません",
							"Warning", JOptionPane.ERROR_MESSAGE);
				}
			}
			String contents = "この内容でよろしいですか？\n" + "Input Folder:" + fname
					+ "\n" + "Encode:" + (String) resultt + "\n"
					+ "Output file:" + results;
			int resultq = JOptionPane.showConfirmDialog(frame, contents, "ok?",
					1, 1);
			System.out.println(resultq);

			if (resultq == 0) {

				makezip(new File(fname), results, (String) resultt);

				JOptionPane.showMessageDialog(frame, "Finish", "圧縮終了しました",
						JOptionPane.INFORMATION_MESSAGE);
			}
			if (resultq == 1) {
				dialoga(frame);
			}

		}
	}

	/**
	 * 圧縮ーzipファイルに対象ファルダ以下の構造樹を再帰的に追加
	 * 
	 * @param zos
	 *            ZIPファイルへの書き込みストリーム。指定の必要無
	 * @param files
	 *            対象ファルダの内容物。フォルダとファイルの場合がある
	 * @param targetdir
	 *            圧縮されるROOTフォルダ。追加対象となったファイルの絶対パスからこれを差し引き、相対パスでエントリに追加する
	 * 
	 */
	static void encode(ZipOutputStream zos, File[] files, File targetdir)
			throws Exception {
		for (File f : files) {
			if (f.isDirectory()) {
				encode(zos, f.listFiles(), targetdir);
			} else {
				// 選択ディレクトリ以下(parentにより未満ではない)でエントリー作成（解凍時に散らばらない）
				// ex. /a/ab/a (target ab)> ab/a
				ZipEntry ze = new ZipEntry(f.getPath().replace('\\', '/')
						.substring(targetdir.getParent().length() + 1));// "/"のため
				zos.putNextEntry(ze);
				InputStream is = new BufferedInputStream(new FileInputStream(f));
				for (;;) {
					int len = is.read(buf);
					if (len < 0)
						break;
					zos.write(buf, 0, len);
				}
				is.close();
			}
		}
	}

	/**
	 * ZIPファイルの作成スクリプト
	 * 
	 * @param targetdir
	 *            一つのZIP圧縮されるディレクトリ
	 * @param out
	 *            作成されるZIPファイルの名前（拡張子を含む）
	 * @param encodestring
	 *            圧縮先ZIPの内部文字コード
	 */
	public static void makezip(File targetdir, String out, String encodestring)
			throws FileNotFoundException, IOException {
		File zipf = new File(out); // 作成するzipファイルの名前
		File[] files = { targetdir };
		// 圧縮対象を相対パスで指定
		ZipOutputStream zos = new ZipOutputStream(new FileOutputStream(zipf));
		zos.setEncoding(encodestring); // Ant版のみ
		try {
			try {
				encode(zos, files, targetdir);
			} catch (Exception e) {
				// TODO 自動生成された catch ブロック
				e.printStackTrace();
			}
		} finally {
			zos.close();
		}
	}

	static byte[] buf = new byte[1024];

	public static JFrame makeframe() {
		final JFrame frame = new JFrame();
		frame.setSize(400, 200);
		frame.setTitle("Multicode ZipUtils");
		JButton button = new JButton();
		GroupLayout buttonLayout = new GroupLayout((JComponent) button);
		button.setLayout(buttonLayout);
		buttonLayout.setVerticalGroup(buttonLayout.createParallelGroup());
		buttonLayout.setHorizontalGroup(buttonLayout.createParallelGroup());
		button.setText("Start Wizard");
		frame.add(button);
		{
			jLabel1 = new JLabel();
			frame.getContentPane().add(jLabel1, BorderLayout.NORTH);
			GridLayout jLabel1Layout = new GridLayout(1, 1);
			jLabel1Layout.setHgap(5);
			jLabel1Layout.setVgap(5);
			jLabel1Layout.setColumns(1);
			jLabel1.setText("終了の際は×ボタンを押してください。Close this app. with ×");
			jLabel1.setLayout(null);
		}
		button.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent evt) {
				System.out.println("button.mouseClicked, event=" + evt);
				// TODO add your code for button.mouseClicked
				try {
					dialoga(frame);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		return frame;
	}

	/**
	 * zipファイルの解凍を行います
	 * 
	 * @param filename
	 *            解凍されるzipファイル
	 * @param outfile
	 *            解凍時に作成されるファルダ名。このフォルダ以下に展開する
	 * @param encode
	 *            zip エンコード
	 * 
	 */
	private static void proccessUnZip2(String filename, String outfile,
			String encode) throws IOException {
		new File(outfile).mkdir();
		ZipFile zipFile = new ZipFile(filename, encode);
		Enumeration enumeration = zipFile.getEntries();
		while (enumeration.hasMoreElements()) {
			ZipEntry entry = (ZipEntry) enumeration.nextElement();
			System.out.println(entry);
			if (entry.isDirectory()) {
				new File(outfile + entry.getName()).mkdirs();
			} else {
				File parent = new File(outfile + entry.getName())
						.getParentFile();
				parent.mkdirs();
				FileOutputStream out = new FileOutputStream(outfile
						+ entry.getName());
				InputStream in = zipFile.getInputStream(entry);
				byte[] buf = new byte[1024];
				int size = 0;
				while ((size = in.read(buf)) != -1) {
					out.write(buf, 0, size);
				}
				out.close();
			}
		}
	}
}
